gtkmm: Gdk::Toplevel Class Reference

gtkmm 4.12.0

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gdk::Toplevel Class Reference

Interface for toplevel surfaces. More...

`#include <gdkmm/toplevel.h>`

Inheritance diagram for Gdk::Toplevel:
[legend]

## Public Types
enum class | State { MINIMIZED = 1 << 0 , MAXIMIZED = 1 << 1 , STICKY = 1 << 2 , FULLSCREEN = 1 << 3 , ABOVE = 1 << 4 , BELOW = 1 << 5 , FOCUSED = 1 << 6 , TILED = 1 << 7 , TOP_TILED = 1 << 8 , TOP_RESIZABLE = 1 << 9 , RIGHT_TILED = 1 << 10 , RIGHT_RESIZABLE = 1 << 11 , BOTTOM_TILED = 1 << 12 , BOTTOM_RESIZABLE = 1 << 13 , LEFT_TILED = 1 << 14 , LEFT_RESIZABLE = 1 << 15 , SUSPENDED = 1 << 16 }

## Public Member Functions
| Toplevel (Toplevel && src) noexcept
Toplevel & | operator= (Toplevel && src) noexcept
| ~Toplevel () noexcept override
GdkToplevel * | gobj ()
| Provides access to the underlying C GObject.
const GdkToplevel * | gobj () const
| Provides access to the underlying C GObject.
void | present (const Glib::RefPtr< ToplevelLayout > & layout)
| Present toplevel after having processed the `Gdk::ToplevelLayout` rules.
bool | minimize ()
| Asks to minimize the toplevel.
bool | lower ()
| Asks to lower the toplevel below other windows.
void | focus (guint32 timestamp)
| Sets keyboard focus to surface.
State | get_state () const
| Gets the bitwise or of the currently active surface state flags, from the `Gdk::Toplevel::State` enumeration.
void | set_title (const Glib::ustring & title)
| Sets the title of a toplevel surface.
void | set_startup_id (const Glib::ustring & startup_id)
| Sets the startup notification ID.
void | set_transient_for (const Glib::RefPtr< Surface > & parent)
| Sets a transient-for parent.
void | set_modal (bool modal=true)
| Sets the toplevel to be modal.
void | set_icon_list (const std::vector< Glib::RefPtr< Texture > > & surfaces)
| Sets a list of icons for the surface.
bool | show_window_menu (const Glib::RefPtr< Event > & event)
| Asks the windowing system to show the window menu.
void | set_decorated (bool decorated=true)
| Sets the toplevel to be decorated.
void | set_deletable (bool deletable=true)
| Sets the toplevel to be deletable.
bool | supports_edge_constraints () const
| Returns whether the desktop environment supports tiled window states.
void | inhibit_system_shortcuts (const Glib::RefPtr< Event > & event)
| Requests that the toplevel inhibit the system shortcuts.
void | restore_system_shortcuts ()
| Restore default system keyboard shortcuts which were previously inhibited.
void | begin_resize (SurfaceEdge edge, const Glib::RefPtr< Device > & device, int button, double x, double y, guint32 timestamp)
| Begins an interactive resize operation.
void | begin_move (const Glib::RefPtr< Device > & device, int button, double x, double y, guint32 timestamp)
| Begins an interactive move operation.
Glib::SignalProxy< void(ToplevelSize &)> | signal_compute_size ()
Glib::PropertyProxy_ReadOnly< State > | property_state () const
| The state of the toplevel.
Glib::PropertyProxy< Glib::ustring > | property_title ()
| The title of the surface.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_title () const
| The title of the surface.
Glib::PropertyProxy< Glib::ustring > | property_startup_id ()
| The startup ID of the surface.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_startup_id () const
| The startup ID of the surface.
Glib::PropertyProxy< Glib::RefPtr< Surface > > | property_transient_for ()
| The transient parent of the surface.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Surface > > | property_transient_for () const
| The transient parent of the surface.
Glib::PropertyProxy< bool > | property_modal ()
| Whether the surface is modal.
Glib::PropertyProxy_ReadOnly< bool > | property_modal () const
| Whether the surface is modal.
Glib::PropertyProxy< bool > | property_decorated ()
| Whether the window manager should add decorations.
Glib::PropertyProxy_ReadOnly< bool > | property_decorated () const
| Whether the window manager should add decorations.
Glib::PropertyProxy< bool > | property_deletable ()
| Whether the window manager should allow to close the surface.
Glib::PropertyProxy_ReadOnly< bool > | property_deletable () const
| Whether the window manager should allow to close the surface.
Glib::PropertyProxy< FullscreenMode > | property_fullscreen_mode ()
| The fullscreen mode of the surface.
Glib::PropertyProxy_ReadOnly< FullscreenMode > | property_fullscreen_mode () const
| The fullscreen mode of the surface.
Glib::PropertyProxy_ReadOnly< bool > | property_shortcuts_inhibited () const
| Whether the surface should inhibit keyboard shortcuts.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| Toplevel ()
| You should derive from this class to use it.
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gdk::Toplevel > | wrap (GdkToplevel * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Interface for toplevel surfaces.

A Gdk::Toplevel is a freestanding toplevel surface.

The Gdk::Toplevel interface provides useful APIs for interacting with the windowing system, such as controlling maximization and size of the surface, setting icons and transient parents for dialogs.

See also
  Gdk::Surface, Gdk::Popup

Since gtkmm 3.98:

## Member Enumeration Documentation

## ◆ State

enum class Gdk::Toplevel::State
| strong

Enumerator
MINIMIZED | The surface is minimized.
MAXIMIZED | The surface is maximized.
STICKY | The surface is sticky.
FULLSCREEN | The surface is maximized without decorations.
ABOVE | The surface is kept above other surfaces.
BELOW | The surface is kept below other surfaces.
FOCUSED | The surface is presented as focused (with active decorations).
TILED | The surface is in a tiled state.
TOP_TILED | Whether the top edge is tiled.
TOP_RESIZABLE | Whether the top edge is resizable.
RIGHT_TILED | Whether the right edge is tiled.
RIGHT_RESIZABLE | Whether the right edge is resizable.
BOTTOM_TILED | Whether the bottom edge is tiled.
BOTTOM_RESIZABLE | Whether the bottom edge is resizable.
LEFT_TILED | Whether the left edge is tiled.
LEFT_RESIZABLE | Whether the left edge is resizable.
SUSPENDED | The surface is not visible to the user.

## Constructor & Destructor Documentation

## ◆ Toplevel() [1/2]

Gdk::Toplevel::Toplevel | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ Toplevel() [2/2]

Gdk::Toplevel::Toplevel | ( | Toplevel && | src | ) |
| noexcept

## ◆ ~Toplevel()

Gdk::Toplevel::~Toplevel | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gdk::Toplevel::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ begin_move()

void Gdk::Toplevel::begin_move | ( | const Glib::RefPtr< Device > & | device,
|  | int | button,
|  | double | x,
|  | double | y,
|  | guint32 | timestamp
| ) |  |

Begins an interactive move operation.

You might use this function to implement draggable titlebars.

Parameters

  device | The device used for the operation.
  button | The button being used to drag, or 0 for a keyboard-initiated drag.
  x | Surface X coordinate of mouse click that began the drag.
  y | Surface Y coordinate of mouse click that began the drag.
  timestamp | Timestamp of mouse click that began the drag (use Gdk::Event::get_time()).

## ◆ begin_resize()

void Gdk::Toplevel::begin_resize | ( | SurfaceEdge | edge,
|  | const Glib::RefPtr< Device > & | device,
|  | int | button,
|  | double | x,
|  | double | y,
|  | guint32 | timestamp
| ) |  |

Begins an interactive resize operation.

You might use this function to implement a “window resize grip.”

Parameters

  edge | The edge or corner from which the drag is started.
  device | The device used for the operation.
  button | The button being used to drag, or 0 for a keyboard-initiated drag.
  x | Surface X coordinate of mouse click that began the drag.
  y | Surface Y coordinate of mouse click that began the drag.
  timestamp | Timestamp of mouse click that began the drag (use Gdk::Event::get_time()).

## ◆ focus()

void Gdk::Toplevel::focus | ( | guint32 | timestamp | ) |

Sets keyboard focus to surface.

In most cases, Gtk::Window::present_with_time() should be used on a Gtk::Window, rather than calling this function.

Parameters

  timestamp | Timestamp of the event triggering the surface focus.

## ◆ get_state()

State Gdk::Toplevel::get_state | ( |  | ) | const

Gets the bitwise or of the currently active surface state flags, from the `Gdk::Toplevel::State` enumeration.

Returns
  Surface state bitfield.

## ◆ get_type()

static GType Gdk::Toplevel::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GdkToplevel * Gdk::Toplevel::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GdkToplevel * Gdk::Toplevel::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ inhibit_system_shortcuts()

void Gdk::Toplevel::inhibit_system_shortcuts | ( | const Glib::RefPtr< Event > & | event | ) |

Requests that the toplevel inhibit the system shortcuts.

This is asking the desktop environment/windowing system to let all keyboard events reach the surface, as long as it is focused, instead of triggering system actions.

If granted, the rerouting remains active until the default shortcuts processing is restored with restore_system_shortcuts(), or the request is revoked by the desktop environment, windowing system or the user.

A typical use case for this API is remote desktop or virtual machine viewers which need to inhibit the default system keyboard shortcuts so that the remote session or virtual host gets those instead of the local environment.

The windowing system or desktop environment may ask the user to grant or deny the request or even choose to ignore the request entirely.

The caller can be notified whenever the request is granted or revoked by listening to the property_shortcuts_inhibited() property.

Parameters

  event | The `Gdk::Event` that is triggering the inhibit request, or `nullptr` if none is available.

## ◆ lower()

bool Gdk::Toplevel::lower | ( |  | ) |

Asks to lower the toplevel below other windows.

The windowing system may choose to ignore the request.

Returns
  `true` if the surface was lowered.

## ◆ minimize()

bool Gdk::Toplevel::minimize | ( |  | ) |

Asks to minimize the toplevel.

The windowing system may choose to ignore the request.

Returns
  `true` if the surface was minimized.

## ◆ operator=()

Toplevel & Gdk::Toplevel::operator= | ( | Toplevel && | src | ) |
| noexcept

## ◆ present()

void Gdk::Toplevel::present | ( | const Glib::RefPtr< ToplevelLayout > & | layout | ) |

Present toplevel after having processed the `Gdk::ToplevelLayout` rules.

If the toplevel was previously not showing, it will be showed, otherwise it will change layout according to layout.

GDK may emit the signal_compute_size() signal to let the user of this toplevel compute the preferred size of the toplevel surface.

Presenting is asynchronous and the specified layout parameters are not guaranteed to be respected.

Parameters

  layout | The `Gdk::ToplevelLayout` object used to layout.

## ◆ property_decorated() [1/2]

Glib::PropertyProxy< bool > Gdk::Toplevel::property_decorated | ( |  | ) |

Whether the window manager should add decorations.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_decorated() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gdk::Toplevel::property_decorated | ( |  | ) | const

Whether the window manager should add decorations.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_deletable() [1/2]

Glib::PropertyProxy< bool > Gdk::Toplevel::property_deletable | ( |  | ) |

Whether the window manager should allow to close the surface.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_deletable() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gdk::Toplevel::property_deletable | ( |  | ) | const

Whether the window manager should allow to close the surface.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_fullscreen_mode() [1/2]

Glib::PropertyProxy< FullscreenMode > Gdk::Toplevel::property_fullscreen_mode | ( |  | ) |

The fullscreen mode of the surface.

Default value: Gdk::FullscreenMode::ON_CURRENT_MONITOR

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_fullscreen_mode() [2/2]

Glib::PropertyProxy_ReadOnly< FullscreenMode > Gdk::Toplevel::property_fullscreen_mode | ( |  | ) | const

The fullscreen mode of the surface.

Default value: Gdk::FullscreenMode::ON_CURRENT_MONITOR

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_modal() [1/2]

Glib::PropertyProxy< bool > Gdk::Toplevel::property_modal | ( |  | ) |

Whether the surface is modal.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_modal() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gdk::Toplevel::property_modal | ( |  | ) | const

Whether the surface is modal.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_shortcuts_inhibited()

Glib::PropertyProxy_ReadOnly< bool > Gdk::Toplevel::property_shortcuts_inhibited | ( |  | ) | const

Whether the surface should inhibit keyboard shortcuts.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_startup_id() [1/2]

Glib::PropertyProxy< Glib::ustring > Gdk::Toplevel::property_startup_id | ( |  | ) |

The startup ID of the surface.

See Gdk::AppLaunchContext for more information about startup feedback.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_startup_id() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gdk::Toplevel::property_startup_id | ( |  | ) | const

The startup ID of the surface.

See Gdk::AppLaunchContext for more information about startup feedback.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_state()

Glib::PropertyProxy_ReadOnly< State > Gdk::Toplevel::property_state | ( |  | ) | const

The state of the toplevel.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_title() [1/2]

Glib::PropertyProxy< Glib::ustring > Gdk::Toplevel::property_title | ( |  | ) |

The title of the surface.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_title() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gdk::Toplevel::property_title | ( |  | ) | const

The title of the surface.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_transient_for() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Surface > > Gdk::Toplevel::property_transient_for | ( |  | ) |

The transient parent of the surface.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_transient_for() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Surface > > Gdk::Toplevel::property_transient_for | ( |  | ) | const

The transient parent of the surface.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ restore_system_shortcuts()

void Gdk::Toplevel::restore_system_shortcuts | ( |  | ) |

Restore default system keyboard shortcuts which were previously inhibited.

This undoes the effect of inhibit_system_shortcuts().

## ◆ set_decorated()

void Gdk::Toplevel::set_decorated | ( | bool | decorated = `true` | ) |

Sets the toplevel to be decorated.

Setting decorated to `false` hints the desktop environment that the surface has its own, client-side decorations and does not need to have window decorations added.

Parameters

  decorated | `true` to request decorations.

## ◆ set_deletable()

void Gdk::Toplevel::set_deletable | ( | bool | deletable = `true` | ) |

Sets the toplevel to be deletable.

Setting deletable to `true` hints the desktop environment that it should offer the user a way to close the surface.

Parameters

  deletable | `true` to request a delete button.

## ◆ set_icon_list()

void Gdk::Toplevel::set_icon_list | ( | const std::vector< Glib::RefPtr< Texture > > & | surfaces | ) |

Sets a list of icons for the surface.

One of these will be used to represent the surface in iconic form. The icon may be shown in window lists or task bars. Which icon size is shown depends on the window manager. The window manager can scale the icon but setting several size icons can give better image quality.

Note that some platforms don't support surface icons.

Parameters

  surfaces | A list of textures to use as icon, of different sizes.

## ◆ set_modal()

void Gdk::Toplevel::set_modal | ( | bool | modal = `true` | ) |

Sets the toplevel to be modal.

The application can use this hint to tell the window manager that a certain surface has modal behaviour. The window manager can use this information to handle modal surfaces in a special way.

You should only use this on surfaces for which you have previously called set_transient_for().

Parameters

  modal | `true` if the surface is modal, `false` otherwise.

## ◆ set_startup_id()

void Gdk::Toplevel::set_startup_id | ( | const Glib::ustring & | startup_id | ) |

Sets the startup notification ID.

When using GTK, typically you should use Gtk::Window::set_startup_id() instead of this low-level function.

Parameters

  startup_id | A string with startup-notification identifier.

## ◆ set_title()

void Gdk::Toplevel::set_title | ( | const Glib::ustring & | title | ) |

Sets the title of a toplevel surface.

The title maybe be displayed in the titlebar, in lists of windows, etc.

Parameters

  title | Title of surface.

## ◆ set_transient_for()

void Gdk::Toplevel::set_transient_for | ( | const Glib::RefPtr< Surface > & | parent | ) |

Sets a transient-for parent.

Indicates to the window manager that surface is a transient dialog associated with the application surface parent. This allows the window manager to do things like center surface on parent and keep surface above parent.

See Gtk::Window::set_transient_for() if you’re using Gtk::Window or Gtk::Dialog.

Parameters

  parent | Another toplevel `Gdk::Surface`.

## ◆ show_window_menu()

bool Gdk::Toplevel::show_window_menu | ( | const Glib::RefPtr< Event > & | event | ) |

Asks the windowing system to show the window menu.

The window menu is the menu shown when right-clicking the titlebar on traditional windows managed by the window manager. This is useful for windows using client-side decorations, activating it with a right-click on the window decorations.

Parameters

  event | A `Gdk::Event` to show the menu for.

Returns
  `true` if the window menu was shown and `false` otherwise.

## ◆ signal_compute_size()

Glib::SignalProxy< void(ToplevelSize &)> Gdk::Toplevel::signal_compute_size | ( |  | ) |

Slot Prototype:
  `void on_my_compute_size(ToplevelSize& size)`

Flags: Run Last

Emitted when the size for the surface needs to be computed, when it is present.

This signal will normally be emitted during or after a call to Gdk::Toplevel::present(), depending on the configuration received by the windowing system. It may also be emitted at any other point in time, in response to the windowing system spontaneously changing the configuration of the toplevel surface.

It is the responsibility of the toplevel user to handle this signal and compute the desired size of the toplevel, given the information passed via the Gdk::ToplevelSize object. Failing to do so will result in an arbitrary size being used as a result.

Parameters

  size | A `Gdk::ToplevelSize`.

## ◆ supports_edge_constraints()

bool Gdk::Toplevel::supports_edge_constraints | ( |  | ) | const

Returns whether the desktop environment supports tiled window states.

Returns
  `true` if the desktop environment supports tiled window states.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::Toplevel > wrap | ( | GdkToplevel * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.